﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.IO;

namespace canny2
{
    public partial class Form1 : Form
    {
            public static int xdot, ydot;
            public static int xdot1, ydot1;
            public static byte[, ,] pxl = new byte[5000, 5000, 4];
            public static byte[, ,] pxl1 = new byte[5000, 5000, 4];
            public static byte[, ,] buf = new byte[5000, 5000, 4];
            public static Bitmap buf_bitmap = new Bitmap(5000, 5000);
            public static Bitmap bit_map1 = new Bitmap(5000, 5000);
            public static Bitmap bit_map2 = new Bitmap(5000, 5000);
            public static string fname, fname_ref;

            public Form1()
            {
                InitializeComponent();
            }

            //Bitmapデータを配列pxlに格納
            public void get_pxl(Bitmap bitmap)
            {
                BitmapData bmpdata = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppRgb);
                byte[] pixcel = new byte[bitmap.Width * bitmap.Height * 4];
                Marshal.Copy(bmpdata.Scan0, pixcel, 0, pixcel.Length);
                int height = bitmap.Height;
                int width = bitmap.Width;
                int length = pixcel.Length;
                byte r, g, b;
                xdot = bitmap.Width; ydot = bitmap.Height;
                int idx = 0;
                for (int y = 0; y < height; y++)
                {
                    for (int x = 0; x < width; x++)
                    {
                        pxl[x, y, 0] = pixcel[idx]; //b;
                        pxl[x, y, 1] = pixcel[idx + 1]; //g;
                        pxl[x, y, 2] = pixcel[idx + 2]; //r;
                        idx += 4;
                    }
                }
                bitmap.UnlockBits(bmpdata);
            }

            //配列pxlのデータをBitmapデータとして格納
            public Bitmap set_pxl(int xwidth, int yheight)
            {
                Bitmap bitmap = new Bitmap(xwidth, yheight);

                BitmapData bmpdata = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppRgb);
                byte[] pixcel = new byte[bitmap.Width * bitmap.Height * 4];
                Marshal.Copy(bmpdata.Scan0, pixcel, 0, pixcel.Length);
                int height = bitmap.Height;
                int width = bitmap.Width;
                int length = pixcel.Length;
                byte r, g, b;
                int idx = 0;
                //int nResidual = bmpdata.Stride - width * 3;
                for (int y = 0; y < height; y++)
                {
                    for (int x = 0; x < width; x++)
                    {
                        pixcel[idx] = pxl[x, y, 0];
                        pixcel[idx + 1] = pxl[x, y, 1];
                        pixcel[idx + 2] = pxl[x, y, 2];
                        idx += 4;
                    }
                }
                Marshal.Copy(pixcel, 0, bmpdata.Scan0, pixcel.Length);
                bitmap.UnlockBits(bmpdata);
                return bitmap;
            }


            private byte[,] ImageProcessingForMask(byte[,] inputdata,
                                                    double[,] mask)
            {
                try
                {
                    // 縦横サイズを配列から読み取り
                    int xsize = xdot;
                    int ysize = ydot;

                    // マスクサイズ読み取り
                    int masksize = mask.GetLength(0);

                    // 画像処理後の2次元配列
                    byte[,] filterdata = new byte[xsize, ysize];

                    // 画像処理
                    for (int i = 0; i < ysize; i++)
                    {
                        for (int j = 0; j < xsize; j++)
                        {
                            double sum = 0;
                            for (int k = -masksize / 2; k <= masksize / 2; k++)
                            {
                                for (int n = -masksize / 2; n <= masksize / 2; n++)
                                {
                                    if (j + n >= 0 && j + n < xsize
                                        && i + k >= 0 && i + k < ysize)
                                    {
                                        sum += (double)inputdata[j + n, i + k]
                                                * mask[n + masksize / 2,
                                                       k + masksize / 2];
                                    }
                                }
                            }
                            filterdata[j, i] = ConvertByte(Math.Abs(sum));
                        }
                    }
                    return filterdata;
                }
                catch
                {
                    Console.WriteLine("フィルタ処理が実行できません。");
                    return null;
                }
            }

            private byte ConvertByte(double num)
            {
                // numが256以上なら255、0未満なら0
                if (num > 255.0)
                {
                    return 255;
                }
                else
                {
                    return (byte)num;
                }
            }

            private byte[,] LoadByteImage()
            {
                try
                {
                    byte[,] data = new byte[xdot, ydot];
                    for (int i = 0; i < ydot; i++)
                    {
                        for (int j = 0; j < xdot; j++)
                        {
                            data[j, i] =
                                (byte)(
                                    (pxl[j, i, 0] +
                                    pxl[j, i, 1] +
                                    pxl[j, i, 2]) / 3
                                    );
                        }
                    }
                    return data;
                }
                catch
                {
                    Console.WriteLine("ファイルが読めません。");
                    return null;
                }
            }

            private void SetByteImage(byte[,] data)
            {
                try
                {
                    // bitmapクラスの画像ピクセル値を配列に挿入
                    for (int i = 0; i < ydot; i++)
                    {
                        for (int j = 0; j < xdot; j++)
                        {
                            // ここではグレイスケールに変換して格納
                            pxl[j, i, 0] = data[j, i];
                            pxl[j, i, 1] = data[j, i];
                            pxl[j, i, 2] = data[j, i];
                        }
                    }
                }
                catch
                {
                    Console.WriteLine("ファイルが読めません。");
                }
            }
            //sobelフィルター、 勾配と強さを計算
            private byte[, ,] sobel(byte[,] data)
            {
                int cx, cy = new int();
                double cxd, cyd = new double();
                double[,] maskx1 = new double[3, 3]{
                {-1, 0, 1},
                {-2, 0, 2},
                {-1, 0, 1}};
                double[,] masky1 = new double[3, 3]{
                {-1, -2, -1},
                {0, 0, 0},
                {1, 2, 1}};
                // 縦横サイズを配列から読み取り
                int xsize = data.GetLength(0);
                int ysize = data.GetLength(1);
                int smax = 0;
                int theta = new int();
                byte[, ,] sbPwTh = new byte[xsize, ysize, 2];
                int[,] sbPwThI = new int[xsize, ysize];

                for (int j = 1; j < ysize - 1; j++)
                {
                    for (int i = 1; i < xsize - 1; i++)
                    {
                        double sumx1 = 0; double sumy1 = 0;
                        for (int n = -1; n < 2; n++)
                        {
                            for (int m = -1; m < 2; m++)
                            {
                                {
                                    sumx1 += data[i + m, j + n] * maskx1[m + 1, n + 1];
                                    sumy1 += data[i + m, j + n] * masky1[m + 1, n + 1];
                                }
                            }
                        }
                        // 勾配と強さを計算
                        cx = (int)Math.Abs(sumx1);
                        cy = (int)Math.Abs(sumy1);
                        cxd = sumx1; cyd = sumy1;
                        sbPwTh[i, j, 0] = ConvertByte(Math.Sqrt(cxd * cxd + cyd * cyd) / 1.0);
                        if (sbPwTh[i, j, 0] > smax) { smax = sbPwTh[i, j, 0]; };
                        theta = (int)(Math.Atan2(cyd, cxd) / Math.PI * 180.0 + 90.0);
                        if (theta < 0) { theta = theta + 180; };
                        if (theta >= 180) { theta = theta - 180; };
                        sbPwTh[i, j, 1] = ConvertByte(theta);
                    }
                }
                for (int j = 1; j < ysize - 1; j++)
                {
                    for (int i = 1; i < xsize - 1; i++)
                    {
                        sbPwTh[i, j, 0] = ConvertByte(255.0 * sbPwTh[i, j, 0] / smax);
                    }
                }
                return sbPwTh;
            }

            private byte[,] canny(byte[, ,] sdata, byte thin, byte tlin)
            {
                int W = xdot; int H = ydot;
                int tw = W - 2; int th = H - 2;
                int k = new int();
                int n = 0;
                byte s0, s1, s2 = new byte();
                byte[] bTheta = new byte[xdot * ydot];
                byte[] bPower = new byte[xdot * ydot];
                byte[] bEdge = new byte[xdot * ydot];
                byte[] bTh = new byte[xdot * ydot];
                byte[] bTl = new byte[xdot * ydot];
                byte[,] edgeC = new byte[xdot, ydot];
                byte edge = new byte();
                byte TH = thin;
                byte TL = tlin;
                int theta = 0;

                // エッジの線細化
                for (int j = 2; j < th; j++)
                {
                    for (int i = 2; i < tw; i++)
                    {
                        n = j * W + i;
                        bPower[n] = sdata[i, j, 0];
                        bTheta[n] = sdata[i, j, 1];
                        theta = (int)bTheta[n];
                        s1 = bPower[n];
                        if ((theta >= 0 && theta <= 22) || (theta >= 157 && theta <= 180))
                        {
                            s0 = bPower[n - 1];
                            s2 = bPower[n + 1];
                            if (s1 > s0 && s1 > s2)
                            {
                                bEdge[n] = s1;
                                bEdge[n - 1] = 0;
                            }
                            else { bEdge[n] = 0; }
                        }
                        else if ((theta > 22 && theta <= 67))
                        {
                            s0 = bPower[n + 1 - W];
                            s2 = bPower[n - 1 + W];
                            if (s1 > s0 && s1 > s2)
                            {
                                bEdge[n] = s1;
                                bEdge[n + 1 - W] = 0; 
                            }
                            else { bEdge[n] = 0; }
                        }
                        else if ((theta > 67 && theta <= 113))
                        {
                            s0 = bPower[n - W];
                            s2 = bPower[n + W];
                            if (s1 > s0 && s1 > s2)
                            {
                                bEdge[n] = s1;
                                bEdge[n - W] = 0;
                            }
                            else { bEdge[n] = 0; }
                        }
                        else if ((theta >= 113 && theta < 157))
                        {
                            s0 = bPower[n - 1 - W];
                            s2 = bPower[n + 1 + W];
                            if (s1 > s0 && s1 > s2)
                            {
                                bEdge[n] = s1;
                                bEdge[n - 1 - W] = 0;
                            }
                            else { bEdge[n] = 0; }
                        }
                    }
                }

                // 閾値処理
                for (int j = 2; j < th; j++)
                {
                    for (int i = 2; i < tw; i++)
                    {
                        n = j * W + i;
                        edge = bEdge[n];
                        if (edge >= TH) { bTh[n] = 255; }
                        else { bTh[n] = 0; };
                        if (edge >= TL) { bTl[n] = 255; }
                        else { bTl[n] = 0; };
                    }
                }

                // 閾値処理で出来た2つの画像を使って出力画像を作成
                tw = W - 2; th = H - 2;
                for (int j = 2; j < th; j++)
                {
                    for (int i = 2; i < tw; i++)
                    {
                        n = j * W + i;
                        theta = (int)sdata[i, j, 1] - 90;
                        if (theta < 0) { theta = theta + 180; };
                        if (theta >= 180) { theta = theta - 180; };
                        if (bTh[n] == 0 && bTl[n] == 255)
                        {
                            if (bTh[n - 1] == 255 && (theta >= 0 && theta <= 22) || (theta >= 157 && theta <= 180)) { bTh[n] = 255; }
                            else if (bTh[n - 1 - W] == 255 && (theta >= 113 && theta < 157)) { bTh[n] = 255; }
                            else if (bTh[n - W] == 255 && (theta > 67 && theta <= 113)) { bTh[n] = 255; }
                            else if (bTh[n + 1 - W] == 255 && (theta > 22 && theta <= 67)) { bTh[n] = 255; }
                            else if (bTh[n + 1] == 255 && (theta >= 0 && theta <= 22) || (theta >= 157 && theta <= 180)) { bTh[n] = 255; }
                            else if (bTh[n + 1 + W] == 255 && (theta > 67 && theta <= 113)) { bTh[n] = 255; }
                            else if (bTh[n + W] == 255 && (theta > 67 && theta <= 113)) { bTh[n] = 255; }
                            else if (bTh[n - 1 + W] == 255 && (theta > 22 && theta <= 67)) { bTh[n] = 255; }
                            else if (bTh[n - 2] == 255 && bTl[n - 1] == 255 && (theta >= 0 && theta <= 22) || (theta >= 157 && theta <= 180))
                            { bTh[n] = 255; bTh[n - 1] = 255; }
                            else if (bTh[n - 2 - W * 2] == 255 && bTl[n - 1 - W] == 255 && (theta >= 113 && theta < 157))
                            { bTh[n] = 255; bTh[n - 1 - W] = 255; }
                            else if (bTh[n - W * 2] == 255 && bTl[n - W] == 255 && (theta > 67 && theta <= 113))
                            { bTh[n] = 255; bTh[n - W] = 255; }
                            else if (bTh[n + 2 - W * 2] == 255 && bTl[n + 1 - W] == 255 && (theta > 22 && theta <= 67))
                            { bTh[n] = 255; bTh[n + 1 - W] = 255; }
                            else if (bTh[n + 2] == 255 && bTl[n + 1] == 255 && (theta >= 0 && theta <= 22) || (theta >= 157 && theta <= 180))
                            { bTh[n] = 255; bTh[n + 1] = 255; }
                            else if (bTh[n + 2 + W * 2] == 255 && bTl[n + 1 + W] == 255 && (theta >= 113 && theta < 157))
                            { bTh[n] = 255; bTh[n + 1 + W] = 255; }
                            else if (bTh[n + W * 2] == 255 && bTl[n + W] == 255 && (theta > 67 && theta <= 113))
                            { bTh[n] = 255; bTh[n + W] = 255; }
                            else if (bTh[n - 2 + W * 2] == 255 && bTl[n - 1 + W] == 255 && (theta > 22 && theta <= 67))
                            { bTh[n] = 255; bTh[n - 1 + W] = 255; }
                            //じゅんじ氏オリジナルのソース　http://d8yd.blog105.fc2.com/?no=84
                            //http://sakef.jp/blog/2011/01/canny01/　現在リンク切れ
                            /*
                            if (buffTh[n - 1] == 255) buffTh[n] = 255;
                            else if (buffTh[n - 1 - W] == 255) buffTh[n] = 255;
                            else if (buffTh[n - W] == 255) buffTh[n] = 255;
                            else if (buffTh[n - W + 1] == 255) buffTh[n] = 255;
                            else if (buffTh[n + 1] == 255) buffTh[n] = 255;
                            else if (buffTh[n + 1 + W] == 255) buffTh[n] = 255;
                            else if (buffTh[n + W] == 255) buffTh[n] = 255;
                            else if (buffTh[n - 1 + W] == 255) buffTh[n] = 255;
                            else if (buffTh[n - 2] == 255) buffTh[n] = buffTh[n - 1] = 255;
                            else if (buffTh[n - 2 - W * 2] == 255) buffTh[n] = buffTh[n - 1 - W] = 255;
                            else if (buffTh[n - W * 2] == 255) buffTh[n] = buffTh[n - W] = 255;
                            else if (buffTh[n - W * 2 + 2] == 255) buffTh[n] = buffTh[n - W + 1] = 255;
                            else if (buffTh[n + 2] == 255) buffTh[n] = buffTh[n + 2] = 255;
                            else if (buffTh[n + 2 + W * 2] == 255) buffTh[n] = buffTh[n + 2 + W * 2] = 255;
                            else if (buffTh[n + W * 2] == 255) buffTh[n] = buffTh[n + W * 2] = 255;
                            else if (buffTh[n - 2 + W * 2] == 255) buffTh[n] = buffTh[n - 2 + W * 2] = 255;
                             */ 
                        }
                        edgeC[i, j] = bTh[n];
                    }
                }
                return edgeC;
            }

            private double[,] gsmask(double sgm)//ガウスフィルター
            {
                double[,] gs = new double[5, 5];
                double[,] gsa = new double[5, 5];
                double gst = 0;
                double gs0 = 0;
                for (int y = -2; y < 3; y++)
                {
                    for (int x = -2; x < 3; x++)
                    {
                        gs[x + 2, y + 2] = 1 / (2 * Math.PI * sgm * sgm)
                            * Math.Exp(-(x * x + y * y) / (2 * sgm * sgm));
                        gst = gst + gs[x + 2, y + 2];
                    }
                }
                for (int y = -2; y < 3; y++)
                {
                    for (int x = -2; x < 3; x++)
                    {
                        gs0 = gs[x + 2, y + 2];
                        gsa[x + 2, y + 2] = gs0 / gst;
                    }
                }
                return gsa;
            }




            public Bitmap filter_canny(Bitmap bit_map1)
            {
                const int maskSize5 = 5;
                double[,] mask = new double[maskSize5, maskSize5];
                double sigma = 0.5;
                byte th = 60;// new byte();
                byte tl = 30;// new byte();
                mask = gsmask(sigma);
                Bitmap bit_map2;
                get_pxl(bit_map1);
                byte[,] tdata;
                byte[,] data1 = LoadByteImage();
                byte[,] filterdata = ImageProcessingForMask(data1, mask);
                byte[, ,] filterdata1 = sobel(filterdata);
                byte[,] filterdata2 = new byte[xdot, ydot];
                for (int j = 0; j < ydot; j++)
                {
                    for (int i = 0; i < xdot; i++)
                    {
                        filterdata2[i, j] = (byte)filterdata1[i, j, 0];
                    }
                }
                tdata = canny(filterdata1, th, tl);
                SetByteImage(tdata);
                bit_map2 = set_pxl(bit_map1.Width, bit_map1.Height);
                return bit_map2;
            }

            private void button1_Click(object sender, EventArgs e)
            {
                string cDir;
                cDir = System.IO.Directory.GetCurrentDirectory();
                fname = cDir + @"\lena.jpg";
                pictureBox1.Image = (Bitmap)Image.FromFile(fname);
            }

            private void button2_Click(object sender, EventArgs e)
            {
                Bitmap bit_map1;
                string cDir;
                cDir = System.IO.Directory.GetCurrentDirectory();
                fname = cDir + @"\lena.jpg";
                bit_map1 = (Bitmap)Image.FromFile(fname);
                pictureBox1.Image = filter_canny(bit_map1);
            }

            private void button3_Click(object sender, EventArgs e)
            {
                Close();
            }
        }
}
